View Issue Details

IDProjectCategoryView StatusLast Update
15920Bug reportsSurvey takingpublic2020-03-02 11:59
ReporterDenisChenu Assigned ToDenisChenu  
PrioritynoneSeverityminor 
Status closedResolutionfixed 
Product Version3.22.7 
Summary15920: PHP notice when submlt a survey
Description

When submit a survey with refurl at 1 : receive a PHP Notice with debug = 2

Steps To Reproduce

Import included survey
Set debug = 2
Activate survey
Launch and submit survey

Additional Information

`$this->LEMsessid``seems empty, copy paster from EM ?

TagsNo tags attached.
Complete LimeSurvey version number (& build)3.22.7 github
I will donate to the project if issue is resolvedNo
Browsernot relevant
Database & DB-Versionnot relevant
Server OS (if known)not relevant
Webserver software & version (if known)not relevant
PHP Versionnot relevant

Activities

DenisChenu

DenisChenu

2020-02-26 19:20

developer  

PHP notice.html (19,688 bytes)   
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en"><head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>PHP notice</title>

<style type="text/css">
/*<![CDATA[*/
html,body,div,span,applet,object,iframe,h1,h2,h3,h4,h5,h6,p,blockquote,pre,a,abbr,acronym,address,big,cite,code,del,dfn,em,font,img,ins,kbd,q,s,samp,small,strike,strong,sub,sup,tt,var,b,u,i,center,dl,dt,dd,ol,ul,li,fieldset,form,label,legend,table,caption,tbody,tfoot,thead,tr,th,td{border:0;outline:0;font-size:100%;vertical-align:baseline;background:transparent;margin:0;padding:0;}
body{line-height:1;}
ol,ul{list-style:none;}
blockquote,q{quotes:none;}
blockquote:before,blockquote:after,q:before,q:after{content:none;}
:focus{outline:0;}
ins{text-decoration:none;}
del{text-decoration:line-through;}
table{border-collapse:collapse;border-spacing:0;}

body {
	font: normal 9pt "Verdana";
	color: #000;
	background: #fff;
}

h1 {
	font: normal 18pt "Verdana";
	color: #f00;
	margin-bottom: .5em;
}

h2 {
	font: normal 14pt "Verdana";
	color: #800000;
	margin-bottom: .5em;
}

h3 {
	font: bold 11pt "Verdana";
}

pre {
	font: normal 11pt Menlo, Consolas, "Lucida Console", Monospace;
}

pre span.error {
	display: block;
	background: #fce3e3;
}

pre span.ln {
	color: #999;
	padding-right: 0.5em;
	border-right: 1px solid #ccc;
}

pre span.error-ln {
	font-weight: bold;
}

.container {
	margin: 1em 4em;
}

.version {
	color: gray;
	font-size: 8pt;
	border-top: 1px solid #aaa;
	padding-top: 1em;
	margin-bottom: 1em;
}

.message {
	color: #000;
	padding: 1em;
	font-size: 11pt;
	background: #f3f3f3;
	-webkit-border-radius: 10px;
	-moz-border-radius: 10px;
	border-radius: 10px;
	margin-bottom: 1em;
	line-height: 160%;
}

.source {
	margin-bottom: 1em;
}

.code pre {
	background-color: #ffe;
	margin: 0.5em 0;
	padding: 0.5em;
	line-height: 125%;
	border: 1px solid #eee;
}

.source .file {
	margin-bottom: 1em;
	font-weight: bold;
}

.traces {
	margin: 2em 0;
}

.trace {
	margin: 0.5em 0;
	padding: 0.5em;
}

.trace.app {
	border: 1px dashed #c00;
}

.trace .number {
	text-align: right;
	width: 2em;
	padding: 0.5em;
}

.trace .content {
	padding: 0.5em;
}

.trace .plus,
.trace .minus {
	display:inline;
	vertical-align:middle;
	text-align:center;
	border:1px solid #000;
	color:#000;
	font-size:10px;
	line-height:10px;
	margin:0;
	padding:0 1px;
	width:10px;
	height:10px;
}

.trace.collapsed .minus,
.trace.expanded .plus,
.trace.collapsed pre {
	display: none;
}

.trace-file {
	cursor: pointer;
	padding: 0.2em;
}

.trace-file:hover {
	background: #f0ffff;
}
/*]]>*/
</style>
</head>

<body>
<div class="container">
	<h1>PHP notice</h1>

	<p class="message">
		Undefined index: 	</p>

	<div class="source">
		<p class="file">/home/shnoulle/public_html/3LTS/application/helpers/SurveyRuntimeHelper.php(562)</p>
		<div class="code"><pre><span class="ln">550</span> 
<span class="ln">551</span>     /**
<span class="ln">552</span>      * Now it's ok ^^
<span class="ln">553</span>      */
<span class="ln">554</span>     private function setArgs()
<span class="ln">555</span>     {
<span class="ln">556</span>         if ($this-&gt;sMove == "movesubmit") {
<span class="ln">557</span>             $aSurveyInfo = getSurveyInfo($this-&gt;iSurveyid, App()-&gt;getLanguage());
<span class="ln">558</span>             $this-&gt;aSurveyInfo = $aSurveyInfo;
<span class="ln">559</span> 
<span class="ln">560</span>             if ($this-&gt;aSurveyInfo['refurl'] == "Y") {
<span class="ln">561</span>                 //Only add this if it doesn't already exist
<span class="error"><span class="ln error-ln">562</span>                 if (!in_array("refurl", $_SESSION[$this-&gt;LEMsessid]['insertarray'])) {
</span><span class="ln">563</span>                     $_SESSION[$this-&gt;LEMsessid]['insertarray'][] = "refurl";
<span class="ln">564</span>                 }
<span class="ln">565</span>             }
<span class="ln">566</span>             resetTimers();
<span class="ln">567</span> 
<span class="ln">568</span>             //Before doing the "templatereplace()" function, check the $this-&gt;aSurveyInfo['url']
<span class="ln">569</span>             //field for limereplace stuff, and do transformations!
<span class="ln">570</span>             $this-&gt;aSurveyInfo['surveyls_url'] = passthruReplace($this-&gt;aSurveyInfo['surveyls_url'], $this-&gt;aSurveyInfo);
<span class="ln">571</span>             $this-&gt;aSurveyInfo['surveyls_url'] = templatereplace($this-&gt;aSurveyInfo['surveyls_url'], array(), $redata, 'URLReplace', false, null, array(), true); // to do INSERTANS substitutions
<span class="ln">572</span>         }
<span class="ln">573</span>     }
<span class="ln">574</span> 
</pre></div>	</div>

	<div class="traces">
		<h2>Stack Trace</h2>
				<table style="width:100%;">
						<tbody><tr class="trace app expanded">
			<td class="number">
				#0			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/home/shnoulle/public_html/3LTS/application/helpers/SurveyRuntimeHelper.php(1586): <strong>SurveyRuntimeHelper</strong>-&gt;<strong>setArgs</strong>()				</div>

				<div class="code"><pre><span class="ln">1581</span>     private function setSurveySettings($surveyid, $args)
<span class="ln">1582</span>     {
<span class="ln">1583</span>         $this-&gt;setVarFromArgs($args); // Set the private variable from $args
<span class="ln">1584</span>         $this-&gt;initTemplate(); // Template settings
<span class="ln">1585</span>         $this-&gt;setJavascriptVar();
<span class="error"><span class="ln error-ln">1586</span>         $this-&gt;setArgs();
</span><span class="ln">1587</span> 
<span class="ln">1588</span>         extract($args);
<span class="ln">1589</span> 
<span class="ln">1590</span>         $this-&gt;LEMsessid = 'survey_'.$this-&gt;iSurveyid;
<span class="ln">1591</span>         $this-&gt;aSurveyInfo                 = getSurveyInfo($this-&gt;iSurveyid, App()-&gt;getLanguage());
</pre></div>			</td>
		</tr>
						<tr class="trace app expanded">
			<td class="number">
				#1			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/home/shnoulle/public_html/3LTS/application/helpers/SurveyRuntimeHelper.php(91): <strong>SurveyRuntimeHelper</strong>-&gt;<strong>setSurveySettings</strong>("948423",
 array("surveyid" =&gt; "948423", "thissurvey" =&gt; array("htmlemail" 
=&gt; "Y", "format" =&gt; "G", "template" =&gt; "fruity", "language" 
=&gt; "en", ...), "thisstep" =&gt; "1", "tokensexist" =&gt; 0, ...))				</div>

				<div class="code"><pre><span class="ln">86</span>      * @param mixed $args
<span class="ln">87</span>      */
<span class="ln">88</span>     public function run($surveyid, $args)
<span class="ln">89</span>     {
<span class="ln">90</span>         // Survey settings
<span class="error"><span class="ln error-ln">91</span>         $this-&gt;setSurveySettings($surveyid, $args);
</span><span class="ln">92</span> 
<span class="ln">93</span>         // Start rendering
<span class="ln">94</span>         $this-&gt;makeLanguageChanger(); //  language changer can be used on any entry screen, so it must be set first
<span class="ln">95</span>         extract($args);
<span class="ln">96</span> 
</pre></div>			</td>
		</tr>
						<tr class="trace app expanded">
			<td class="number">
				#2			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/home/shnoulle/public_html/3LTS/application/controllers/survey/index.php(590): <strong>SurveyRuntimeHelper</strong>-&gt;<strong>run</strong>("948423",
 array("surveyid" =&gt; "948423", "thissurvey" =&gt; array("htmlemail" 
=&gt; "Y", "format" =&gt; "G", "template" =&gt; "fruity", "language" 
=&gt; "en", ...), "thisstep" =&gt; "1", "tokensexist" =&gt; 0, ...))				</div>

				<div class="code"><pre><span class="ln">585</span>         unset($redata);
<span class="ln">586</span>         $redata = compact(array_keys(get_defined_vars()));
<span class="ln">587</span>         Yii::import('application.helpers.SurveyRuntimeHelper');
<span class="ln">588</span>         $tmp = new SurveyRuntimeHelper();
<span class="ln">589</span>         // try {
<span class="error"><span class="ln error-ln">590</span>             $tmp-&gt;run($surveyid, $redata);
</span><span class="ln">591</span>         // } catch (WrongTemplateVersionException $ex) {
<span class="ln">592</span>         //     echo $ex-&gt;getMessage();
<span class="ln">593</span>         // }
<span class="ln">594</span>     }
<span class="ln">595</span> 
</pre></div>			</td>
		</tr>
						<tr class="trace app collapsed">
			<td class="number">
				#3			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/home/shnoulle/public_html/3LTS/application/controllers/survey/index.php(24): <strong>index</strong>-&gt;<strong>action</strong>()				</div>

				<div class="code"><pre><span class="ln">19</span>     public $oTemplate;
<span class="ln">20</span> 
<span class="ln">21</span>     public function run()
<span class="ln">22</span>     {
<span class="ln">23</span>         useFirebug();
<span class="error"><span class="ln error-ln">24</span>         $this-&gt;action();
</span><span class="ln">25</span>     }
<span class="ln">26</span> 
<span class="ln">27</span>     public function action()
<span class="ln">28</span>     {
<span class="ln">29</span>         global $surveyid;
</pre></div>			</td>
		</tr>
						<tr class="trace core collapsed">
			<td class="number">
				#4			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/home/shnoulle/public_html/3LTS/framework/web/actions/CAction.php(76): <strong>index</strong>-&gt;<strong>run</strong>()				</div>

				<div class="code"><pre><span class="ln">71</span>     {
<span class="ln">72</span>         $method=new ReflectionMethod($this, 'run');
<span class="ln">73</span>         if($method-&gt;getNumberOfParameters()&gt;0)
<span class="ln">74</span>             return $this-&gt;runWithParamsInternal($this, $method, $params);
<span class="ln">75</span> 
<span class="error"><span class="ln error-ln">76</span>         $this-&gt;run();
</span><span class="ln">77</span>         return true;
<span class="ln">78</span>     }
<span class="ln">79</span> 
<span class="ln">80</span>     /**
<span class="ln">81</span>      * Executes a method of an object with the supplied named parameters.
</pre></div>			</td>
		</tr>
						<tr class="trace core collapsed">
			<td class="number">
				#5			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/home/shnoulle/public_html/3LTS/framework/web/CController.php(308): <strong>CAction</strong>-&gt;<strong>runWithParams</strong>(array("sid" =&gt; "948423"))				</div>

				<div class="code"><pre><span class="ln">303</span>     {
<span class="ln">304</span>         $priorAction=$this-&gt;_action;
<span class="ln">305</span>         $this-&gt;_action=$action;
<span class="ln">306</span>         if($this-&gt;beforeAction($action))
<span class="ln">307</span>         {
<span class="error"><span class="ln error-ln">308</span>             if($action-&gt;runWithParams($this-&gt;getActionParams())===false)
</span><span class="ln">309</span>                 $this-&gt;invalidActionParams($action);
<span class="ln">310</span>             else
<span class="ln">311</span>                 $this-&gt;afterAction($action);
<span class="ln">312</span>         }
<span class="ln">313</span>         $this-&gt;_action=$priorAction;
</pre></div>			</td>
		</tr>
						<tr class="trace core collapsed">
			<td class="number">
				#6			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/home/shnoulle/public_html/3LTS/framework/web/CController.php(286): <strong>CController</strong>-&gt;<strong>runAction</strong>(index)				</div>

				<div class="code"><pre><span class="ln">281</span>      * @see runAction
<span class="ln">282</span>      */
<span class="ln">283</span>     public function runActionWithFilters($action,$filters)
<span class="ln">284</span>     {
<span class="ln">285</span>         if(empty($filters))
<span class="error"><span class="ln error-ln">286</span>             $this-&gt;runAction($action);
</span><span class="ln">287</span>         else
<span class="ln">288</span>         {
<span class="ln">289</span>             $priorAction=$this-&gt;_action;
<span class="ln">290</span>             $this-&gt;_action=$action;
<span class="ln">291</span>             CFilterChain::create($this,$action,$filters)-&gt;run();
</pre></div>			</td>
		</tr>
						<tr class="trace core collapsed">
			<td class="number">
				#7			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/home/shnoulle/public_html/3LTS/framework/web/CController.php(265): <strong>CController</strong>-&gt;<strong>runActionWithFilters</strong>(index, array())				</div>

				<div class="code"><pre><span class="ln">260</span>         {
<span class="ln">261</span>             if(($parent=$this-&gt;getModule())===null)
<span class="ln">262</span>                 $parent=Yii::app();
<span class="ln">263</span>             if($parent-&gt;beforeControllerAction($this,$action))
<span class="ln">264</span>             {
<span class="error"><span class="ln error-ln">265</span>                 $this-&gt;runActionWithFilters($action,$this-&gt;filters());
</span><span class="ln">266</span>                 $parent-&gt;afterControllerAction($this,$action);
<span class="ln">267</span>             }
<span class="ln">268</span>         }
<span class="ln">269</span>         else
<span class="ln">270</span>             $this-&gt;missingAction($actionID);
</pre></div>			</td>
		</tr>
						<tr class="trace core collapsed">
			<td class="number">
				#8			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/home/shnoulle/public_html/3LTS/framework/web/CWebApplication.php(282): <strong>CController</strong>-&gt;<strong>run</strong>("index")				</div>

				<div class="code"><pre><span class="ln">277</span>         {
<span class="ln">278</span>             list($controller,$actionID)=$ca;
<span class="ln">279</span>             $oldController=$this-&gt;_controller;
<span class="ln">280</span>             $this-&gt;_controller=$controller;
<span class="ln">281</span>             $controller-&gt;init();
<span class="error"><span class="ln error-ln">282</span>             $controller-&gt;run($actionID);
</span><span class="ln">283</span>             $this-&gt;_controller=$oldController;
<span class="ln">284</span>         }
<span class="ln">285</span>         else
<span class="ln">286</span>             throw new CHttpException(404,Yii::t('yii','Unable to resolve the request "{route}".',
<span class="ln">287</span>                 array('{route}'=&gt;$route===''?$this-&gt;defaultController:$route)));
</pre></div>			</td>
		</tr>
						<tr class="trace core collapsed">
			<td class="number">
				#9			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/home/shnoulle/public_html/3LTS/framework/web/CWebApplication.php(141): <strong>CWebApplication</strong>-&gt;<strong>runController</strong>("survey/index/sid/948423")				</div>

				<div class="code"><pre><span class="ln">136</span>             foreach(array_splice($this-&gt;catchAllRequest,1) as $name=&gt;$value)
<span class="ln">137</span>                 $_GET[$name]=$value;
<span class="ln">138</span>         }
<span class="ln">139</span>         else
<span class="ln">140</span>             $route=$this-&gt;getUrlManager()-&gt;parseUrl($this-&gt;getRequest());
<span class="error"><span class="ln error-ln">141</span>         $this-&gt;runController($route);
</span><span class="ln">142</span>     }
<span class="ln">143</span> 
<span class="ln">144</span>     /**
<span class="ln">145</span>      * Registers the core application components.
<span class="ln">146</span>      * This method overrides the parent implementation by registering additional core components.
</pre></div>			</td>
		</tr>
						<tr class="trace core collapsed">
			<td class="number">
				#10			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/home/shnoulle/public_html/3LTS/framework/base/CApplication.php(185): <strong>CWebApplication</strong>-&gt;<strong>processRequest</strong>()				</div>

				<div class="code"><pre><span class="ln">180</span>     public function run()
<span class="ln">181</span>     {
<span class="ln">182</span>         if($this-&gt;hasEventHandler('onBeginRequest'))
<span class="ln">183</span>             $this-&gt;onBeginRequest(new CEvent($this));
<span class="ln">184</span>         register_shutdown_function(array($this,'end'),0,false);
<span class="error"><span class="ln error-ln">185</span>         $this-&gt;processRequest();
</span><span class="ln">186</span>         if($this-&gt;hasEventHandler('onEndRequest'))
<span class="ln">187</span>             $this-&gt;onEndRequest(new CEvent($this));
<span class="ln">188</span>     }
<span class="ln">189</span> 
<span class="ln">190</span>     /**
</pre></div>			</td>
		</tr>
						<tr class="trace app collapsed">
			<td class="number">
				#11			</td>
			<td class="content">
				<div class="trace-file">
											<div class="plus">+</div>
						<div class="minus">–</div>
										&nbsp;/home/shnoulle/public_html/3LTS/index.php(194): <strong>CApplication</strong>-&gt;<strong>run</strong>()				</div>

				<div class="code"><pre><span class="ln">189</span> require_once APPPATH . 'core/LSYii_Application' . EXT;
<span class="ln">190</span> 
<span class="ln">191</span> $config = require_once(APPPATH . 'config/internal' . EXT);
<span class="ln">192</span> 
<span class="ln">193</span> Yii::$enableIncludePath = false;
<span class="error"><span class="ln error-ln">194</span> Yii::createApplication('LSYii_Application', $config)-&gt;run();
</span><span class="ln">195</span> 
<span class="ln">196</span> /* End of file index.php */
<span class="ln">197</span> /* Location: ./index.php */
</pre></div>			</td>
		</tr>
				</tbody></table>
	</div>

	<div class="version">
		2020-02-26 19:19:40 Apache/2.4.38 (Debian) <a href="http://www.yiiframework.com/">Yii Framework</a>/1.1.22-dev	</div>
</div>

<script type="text/javascript">
/*<![CDATA[*/
var traceReg = new RegExp("(^|\\s)trace-file(\\s|$)");
var collapsedReg = new RegExp("(^|\\s)collapsed(\\s|$)");

var e = document.getElementsByTagName("div");
for(var j=0,len=e.length;j<len;j++){
	if(traceReg.test(e[j].className)){
		e[j].onclick = function(){
			var trace = this.parentNode.parentNode;
			if(collapsedReg.test(trace.className))
				trace.className = trace.className.replace("collapsed", "expanded");
			else
				trace.className = trace.className.replace("expanded", "collapsed");
		}
	}
}
/*]]>*/
</script>



</body></html>
PHP notice.html (19,688 bytes)   
DenisChenu

DenisChenu

2020-02-26 19:29

developer   ~56211

$this->setArgs(); is done before $this->LEMsessid = 'survey_'.$this->iSurveyid;

My opinion : $this->LEMsessid = 'survey_'.$this->iSurveyid; must be moved in setVarFromArgs

DenisChenu

DenisChenu

2020-02-27 08:25

developer   ~56215

Looking at code : 4.X have same issue

DenisChenu

DenisChenu

2020-02-27 08:25

developer   ~56216

@cdorin, @ollehaer

I have the fix : OK to fix in 3.X ? broke survey submit but only with debug set to 2.

DenisChenu

DenisChenu

2020-02-27 08:39

developer   ~56217

Fix committed to master branch: http://bugs.limesurvey.org/plugin.php?page=Source/view&amp;id=29623

lime_release_bot

lime_release_bot

2020-03-02 11:59

administrator   ~56270

Fixed in Release 4.1.8+200302

Related Changesets

LimeSurvey: master 10454b9f

2020-02-27 08:38:53

DenisChenu

Details Diff
Fixed issue 15920: PHP notice when submit a survey with refurl
Dev: move $this->LEMsessid to setVarFromArgs function
Dev: send surveyid from the param in setVarFromArgs
Affected Issues
15920
mod - application/helpers/SurveyRuntimeHelper.php Diff File

Issue History

Date Modified Username Field Change
2020-02-26 19:20 DenisChenu New Issue
2020-02-26 19:20 DenisChenu File Added: limesurvey_survey_urlNottice.lss
2020-02-26 19:20 DenisChenu File Added: PHP notice.html
2020-02-26 19:29 DenisChenu Note Added: 56211
2020-02-27 08:25 DenisChenu Note Added: 56215
2020-02-27 08:25 DenisChenu Note Added: 56216
2020-02-27 08:37 DenisChenu Assigned To => DenisChenu
2020-02-27 08:37 DenisChenu Status new => assigned
2020-02-27 08:39 DenisChenu Changeset attached => LimeSurvey master 10454b9f
2020-02-27 08:39 DenisChenu Note Added: 56217
2020-02-27 08:39 DenisChenu Resolution open => fixed
2020-03-02 11:59 lime_release_bot Note Added: 56270
2020-03-02 11:59 lime_release_bot Status assigned => closed